
#pragma once

class CCamera
{
public:
	void Create(PR_CAMERA &prc, PR_DWORD dwCreateMode=CAMFLAG_AIM_TARGET);
	void GetTarget(PR_REAL &x, PR_REAL &y, PR_REAL &z);
	void GetPos(PR_REAL &x, PR_REAL &y, PR_REAL &z);
	PR_CAMERA* GetPRCamera();
	void SetTarget(PR_REAL x, PR_REAL y, PR_REAL z);
	void SetPos(PR_REAL x, PR_REAL y, PR_REAL z);
	void MovePos(PR_REAL dx, PR_REAL dy, PR_REAL dz);
	void MoveTarget(PR_REAL dx, PR_REAL dy, PR_REAL dz);
	// operations
	CCamera();
	~CCamera();

	bool IsValid() { return m_nIsValid == 1; }
	void Create(PR_DWORD dwCreateMode=CAMFLAG_AIM_TARGET);
	void Activate(bool bSetView=true); // call last, every frame.

	void HandleMouseLook(bool bInvLook=false); // once per frame for mouse look OR:
	void HandleMouseLook(int dx, int dy, bool bInvLook=false); // once per frame for mouse look.
	void OnMove(PR_REAL fDelta); // once per frame if moving forward or back
	void OnStraffe(PR_REAL fDelta); // once per frame if straffe forward or back

	void Release();

	// inspection / debugging
	void GetAngle(int &nTheta, int &nPsi);

protected:
	// operations
	void Init();

protected:
	// data
	int m_nTheta, m_nPsi; // orientation

	PR_CAMERA *m_PRCamera;

	int m_nIsValid;
};
