
#pragma once

class CLight
{
public:
	friend class CLightList;

	// operations
	CLight();
	~CLight();

	void SetPos(PR_REAL x, PR_REAL y, PR_REAL z);
	void SetColor(PR_REAL x, PR_REAL y, PR_REAL z);
	void SetColor(int r, int g, int b);
	void SetStrength(PR_REAL fIntensity);
	void TurnOn();
	void TurnOff();

protected:
	// operations
	void Init();

protected:
	// data
	int m_nIndex;				  // index in parent's light list
	PR_LIGHTLIST *m_pPRLightList; // ptr to parent's light list
};

class CLightList
{
public:
	CLight* GetLight(UINT nIndex);
	// operations
	CLightList();
	~CLightList();

	bool Create(int nMaxLights);
	CLight* CreateLight(PR_DWORD dwLightType=DIRECTIONAL_LIGHT, PR_DWORD dwLightFalloff=200);
	void DoTransform();
	void Release();

protected:
	// operations
	void Init();

protected:
	// data
	PR_LIGHTLIST m_PRLightList;
	CLight *m_pLights;

	int m_nNumLights, m_nMaxLights;
};
