// main.cpp - darrennix@msn.com
// http://homepages.msn.com/RedmondAve/darrennix
// www.egerter.com  www.gamedev.com  www.flipcode.com
/////////////////////////////////////////////////////////////////////

// Note: My CDirectDraw wrapper class currently isn't integrated
//       for use with PowerRender, so this sample is not very
//		 modular at all and will look a little obfuscated because
//       I had to cut and paste code from some of my libraries.
//

#include <conio.h>
#include <stdlib.h>

#include <stdarg.h>

#include <pr.h>
#include <prgui.h>

#ifdef __3DFX__
#include <pr3dfx.h>
#include <glide.h>
#endif

#ifdef WIN32
#include <windows.h>
#include <winutil.h>
#endif

extern "C" {
#include <prdev.h>
}

#include "devdlg.h"

// My includes
#include <CAviFile.h>
#include "camera.h"
#include "lights.h"

///G L O B A L   V A R I A B L E S/////////////////////////////////////

extern "C" HWND hWndMain;
extern "C" LPDIRECTDRAW wgtpdd1;

CAviFile g_AviFile;

CLightList g_LightList;

CCamera g_Camera;
PR_VIEWPORT viewport;
int g_modeWidth, g_modeHeight;

// action - stuff for a trippy demo effect
#define ASPECT_COUNT 60.0
#define FIELD_COUNT 120.0
#define TILT_COUNT 70.0
#define AMBIENT_COUNT 10
PR_REAL 
	g_rAspectDelta = -0.0175,
	g_rAspectCount = ASPECT_COUNT,
	g_rFieldDelta = 0.01,
	g_rFieldCount = FIELD_COUNT,
	g_rTiltDelta = 0.25,
	g_rTiltCount = TILT_COUNT,
	g_fAmbDelta = 10.0,
	g_fAmbCount = AMBIENT_COUNT;

PR_REAL xr=1.0f, yr=1.0f, zr=1.0f;
float xd=0.1f, yd=-0.1f, zd=0.1f;
const int ROT_COUNT = 60;
int rcount = ROT_COUNT;

PR_OBJECT *g_object;
PR_ENTITY *g_entity;

///D E B U G G I N G///////////////////////////////////////////////////

#ifdef VERIFY
#undef VERIFY
#endif

#define VERIFY(B)\
	if(!(B))\
	{\
		MessageBeep(MB_ICONSTOP);\
		char msg[200];\
		sprintf(msg, "Error returned from function %s in file %s, called at line %d.",\
			#B, __FILE__, __LINE__);\
		PRGUI_Error(msg);\
		return false;\
	}

#ifndef ASSERT
#define ASSERT(B) VERIFY(B)
#endif

///////////////////////////////////////////////////////////////////////

bool InitApplication()
{
	// initialize rendering system...
	//PR_Settings.UseWindowed = 1;
	ChooseDevice();
	PR_Initialize(1000);
	InitializeDevices();

	// allocate stuff
	PR_AllocMaterials(32);
	PR_AllocTextures(32);
	PR_AllocShadeTables(2);
	PR_AllocLights (&scenelights, 10);

	// set display mode
	g_modeWidth = PR_VideoModes[0].width;
	g_modeHeight = PR_VideoModes[0].height;
	PR_SetMode (g_modeWidth, g_modeHeight, 60);

	// setup viewport (full screen)
	PR_OpenViewport (&viewport, 0, 0, g_modeWidth-1, g_modeHeight-1, VIEW_PLAIN);
	PR_SetViewport (&viewport);

	// load objects
	PR_SetTexturePath (".\\");
	PR_SetTablePath (".\\");

	g_object = PR_LoadPRO ("teapot1.pro", LOAD_NORMAL);
	if (!g_object)
		PR_FatalError ("Cannot find pro!", "main");

	PR_REAL dx, dy, dz;
	PR_CenterObject(g_object, &dx, &dy, &dz);

	PR_SetMaterialMethod(&PR_ObjectMaterialList[0], T_XGOURAUD_TEXTURED8);
	PR_SetMaterialAlpha(&PR_ObjectMaterialList[0], 128);
	PR_SetObjectMaterial(g_object, 0);

	// create camera
	g_Camera.Create();
	g_Camera.SetPos(0, 0, -700.0);

	// create entities
	g_entity = PR_CreateEntity(g_object, "domearena");
	if(!g_entity)
		PR_FatalError("Cannot creat entity!", "main");

	// Initialize lights
	PR_AmbientRed = 100;
	PR_AmbientGreen = 100;
	PR_AmbientBlue = 100;

	g_LightList.Create(10); // max lights
	
	CLight *pLight = g_LightList.CreateLight();
	pLight->SetPos(1.0f, 0.0f, 0.0f);
	pLight->SetColor(100, 100, 100);
	pLight->TurnOn();

	return true;
}

int main()
{
	VERIFY(InitApplication());
	
	PR_UDWORD BLACK = PRGFX_MakeColor(0,0,0);
	
	installkbd();

	///////////////////////////
	// Load Klowner's avi sequence
	VERIFY(g_AviFile.Open("klowner.avi"));
	VERIFY(g_AviFile.StartVideoRetrieve(0));

	///////////////////////////
	// Calculate stuff for the main loop
	LPBITMAPINFOHEADER pBmp;			// Decompressed video frame

	LONG
		lFrameTime=0,					// Millisecs into video clip
		lNewTime=0,						// Current time
		lOldTime=timeGetTime(),			// Time at last drawn frame
		lElapsedTime=0,					// Time between drawn frames
		lVideoDirection=1;				// 1=Forward -1=Reverse

	LPBITMAPINFO pVideoFormat =			// AVI File's video format
		g_AviFile.GetVideoFormat(0);

	/////////////////////////////////////////////////////////////////
	LPDIRECTDRAWSURFACE pFrameSurface;	// I'll use ddraw to render

	// Describe Frame Surface...
	DDSURFACEDESC ddsd;
	memset(&ddsd, 0, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(DDSURFACEDESC);
	ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
	ddsd.dwWidth = pVideoFormat->bmiHeader.biWidth; // in pixels
	ddsd.dwHeight = pVideoFormat->bmiHeader.biHeight;

	// Create...
	VERIFY(wgtpdd1->CreateSurface(&ddsd, &pFrameSurface, NULL) == DD_OK);
	if(!pFrameSurface) return NULL;

	// Set Transparant Color (black)...
	DDCOLORKEY ddck;
    ddck.dwColorSpaceLowValue = 0;
    ddck.dwColorSpaceHighValue = 0;
    VERIFY(pFrameSurface->SetColorKey(DDCKEY_SRCBLT, &ddck) == DD_OK);
	/////////////////////////////////////////////////////////////////

	RECT rcDest;						// Destination rect of video
	
	// (center the video in the display)
	{ // (with optimal memory usage via limited scope precalc)
		int nHalfWidth = (pVideoFormat->bmiHeader.biWidth >> 1),
			nHalfHeight = (pVideoFormat->bmiHeader.biHeight >> 1);
		
		rcDest.left = 320 - nHalfWidth;
		rcDest.top = 240 - nHalfHeight;
		rcDest.right = 320 + nHalfWidth;
		rcDest.bottom = 240 + nHalfHeight;
	}
	
	// Enter the main frame loop
	while (!kbdon[KEY_ESC])
    {
		lNewTime = timeGetTime();
		lElapsedTime = lNewTime - lOldTime;
		lFrameTime += lElapsedTime * lVideoDirection;

		UpdateMessages();
		
		/* if (PR_LostSurface)
		PR_RestoreAll ();*/
		
		PRGFX_SetColor (BLACK);
		PR_ClearViewport(&viewport);

		PR_NewFrame ();

		// (not needed for this app)
		//g_Camera.HandleMouseLook(true);
		
		g_Camera.Activate();

		//////////////////////////////////////////////////////
		// Render the current AVI frame
		
		LPBITMAPINFOHEADER pBmp;
	
		g_AviFile.GetVideoFrameAtTime(0, lFrameTime, &pBmp);

		if(!pBmp)
		{
			lVideoDirection = -lVideoDirection;
			continue;
		}
	
		// Copy frame to IDirectDrawSurface object...
		ASSERT(pFrameSurface);
		
		LPBITMAPINFO pBmpInfo = (LPBITMAPINFO)pBmp;
		LPBITMAPINFOHEADER pBmpInfoHeader = (LPBITMAPINFOHEADER)pBmpInfo;
		
		HDC hdc;
		VERIFY(pFrameSurface->GetDC(&hdc) == DD_OK);
		
		LPBYTE pBmpBits = ((LPBYTE)pBmpInfo) + pBmpInfo->bmiHeader.biSize;
		
		LPBYTE pGDIBits;
		HBITMAP hBmp = CreateDIBSection(hdc, pBmpInfo, DIB_RGB_COLORS, (LPVOID*)&pGDIBits, NULL, 0);
		ASSERT(hBmp);
		
		memcpy(pGDIBits, pBmpBits, pBmpInfoHeader->biSizeImage);
		
		HDC hBmpDC = CreateCompatibleDC(hdc);
		ASSERT(hBmpDC);
		
		HGDIOBJ pOldObj = SelectObject(hBmpDC, hBmp);
		BitBlt(hdc, 0, 0, pBmpInfoHeader->biWidth, pBmpInfoHeader->biHeight, hBmpDC, 0, 0, SRCCOPY);
		
		if(pOldObj) SelectObject(hBmpDC, pOldObj);
		DeleteObject(hBmp);
		
		ASSERT(pFrameSurface->ReleaseDC(hdc) == DD_OK);

		// Blit IDirectDrawSurface object to back buffer...

		HRESULT hResult;
		LPDIRECTDRAWSURFACE2 pFrameSurface2;
		pFrameSurface->QueryInterface(IID_IDirectDrawSurface2, (LPVOID*)&pFrameSurface2);
		hResult = wgtBackBuffer->Blt(&rcDest, pFrameSurface2, NULL, DDBLT_KEYSRC | DDBLT_WAIT | DDBLT_ASYNC, NULL);
		if(hResult == DDERR_SURFACELOST)
			VERIFY(pFrameSurface->Restore()==DD_OK);
		
		//////////////////////////////////////////////////////
		
		PR_OpenScreen (PR_BACKBUFFER);
		//g_LightList.GetLight(0)->SetColor(100, 100, 100);
		g_LightList.DoTransform();

		PR_RotateEntity (g_entity, xr, yr, zr);
		xr += xd;
		yr += yd;
		zr += zd;

		if(!rcount--)
		{
			xd = -xd;
			yd = -yd;
			zd = -zd;
			rcount = ROT_COUNT<<1;
		}

		PR_TransformEntity(g_entity);
		PR_RenderEntity(g_entity);
		
		PR_RenderFrame ();
		
		PR_Flip (1);
		
		///////////////////////////////////////////
		// Demo effect for next frame
		PR_CAMERA *pCam = g_Camera.GetPRCamera();

		pCam->aspect_ratio += g_rAspectDelta;
		if(--g_rAspectCount <= 0)
		{
			g_rAspectDelta = -g_rAspectDelta;
			g_rAspectCount = ASPECT_COUNT + rand()%20;
		}

		pCam->fov += g_rFieldDelta;
		if(--g_rFieldCount <= 0)
		{
			g_rFieldDelta = -g_rFieldDelta;

			g_rFieldCount = FIELD_COUNT + rand()%20;
		}

		pCam->tilt_angle += g_rTiltDelta;
		if(--g_rTiltCount <= 0)
		{
			g_rTiltDelta = -g_rTiltDelta;
			g_rTiltCount = TILT_COUNT + rand()%20;
		}

		lOldTime = lNewTime;
	}

	VERIFY(g_AviFile.EndVideoRetrieve(0));
	g_AviFile.Release();

	////////////////////////////
	// Shutdown application
			
	// Free all entities...
	PR_FreeEntity (g_entity);
			
	// Free all objects...
	PR_FreeObject (g_object);
			
	// Close all viewports...
	PR_CloseViewport (&viewport);
			
	// Delete the usual stuff
	PR_DeleteAllShadeTables ();
	PR_DeleteAllTextures ();
	PR_DeleteAllMaterials ();
			
	PR_ShutDown ();
	
	uninstallkbd ();
	return -1;
}