// CDirectDraw.h: interface for the CDirectDraw class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CDIRECTDRAW_H__D04E7E03_F7D7_11D2_84CC_D391C7F77431__INCLUDED_)
#define AFX_CDIRECTDRAW_H__D04E7E03_F7D7_11D2_84CC_D391C7F77431__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <ddraw.h>
#include <CBmpFile.h>

// Defines...
#ifndef VERIFY
#define VERIFY ProcessResult
#endif

#ifndef RELEASE
#define RELEASE(I) if((I)) { (I)->Release(); (I) = NULL; }
#endif

// Class Declarations...
class CDirectDraw  
{
public:
	void ClearSurface(LPDIRECTDRAWSURFACE pSurface);
	bool CreateFor3D(HWND hWnd, int nWidth, int nHeight, int nBitDepth);
	int Create(HWND hWnd, int nWidth, int nHeight, int nBpp, DWORD dwExtraCaps=0);
	
	LPDIRECTDRAWSURFACE CreateSurface(CBmpFile &bmp);
	LPDIRECTDRAWSURFACE CreateSurface(int nWidth, int nHeight);
	LPDIRECTDRAWSURFACE CreateSurface(LPBITMAPINFO pBmpInfo);
	
	LPVOID LockSurface(LPDIRECTDRAWSURFACE lpSurface=NULL, LPDDSURFACEDESC lpDesc=NULL);
	void UnlockSurface(LPVOID lpData, LPDIRECTDRAWSURFACE lpSurface=NULL);

	// These blit onto surfaces
	void BlitToSurface(LPDIRECTDRAWSURFACE pDestSurface, LPBITMAPINFO pBmpInfo);
	
	// These blit onto the back buffer
	bool Blit(LPRECT pDestRect, LPDIRECTDRAWSURFACE pSurface);
	bool Blit(LPRECT pDestRect, CBmpFile &bmp);

	bool GetDC(HDC * pHDC);
	bool ReleaseDC(HDC *pHDC);

	int GetBpp();
	LPDIRECTDRAWSURFACE GetBackSurface();
	LPDIRECTDRAW GetDirectDraw();

	void Flip();
	
	CDirectDraw();
	virtual ~CDirectDraw();
	void Release();

protected:
	bool CreateZBuffer(bool bHardware, int nWidth, int nHeight);
	void ProcessResultA(HRESULT, LPSTR, int);
	void Init();
	LPDIRECTDRAWSURFACE m_lpPrimarySurface, m_lpBackSurface, m_lpZSurface;
	LPDIRECTDRAW m_lpDD;

	int m_nBpp;
};

#endif // !defined(AFX_CDIRECTDRAW_H__D04E7E03_F7D7_11D2_84CC_D391C7F77431__INCLUDED_)
